unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SChart, Menus, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    SChart2: TSChart;
    Panel1: TPanel;
    SChart3: TSChart;
    SChart4: TSChart;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Line1: TMenuItem;
    Bar1: TMenuItem;
    Area1: TMenuItem;
    N1: TMenuItem;
    N3D1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Area2: TMenuItem;
    Bar2: TMenuItem;
    HorizontalBar1: TMenuItem;
    N2: TMenuItem;
    Stacked1: TMenuItem;
    Stacked1001: TMenuItem;
    MainMenu1: TMainMenu;
    Doughnut1: TMenuItem;
    Exit1: TMenuItem;
    N3: TMenuItem;
    N3D2: TMenuItem;
    SChart1: TSChart;
    procedure FormShow(Sender: TObject);
    procedure SChart1Click(Sender: TObject; ASeries, APoint,
      ALegend: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure SChart3Click(Sender: TObject; ASeries, APoint,
      ALegend: Integer);
    procedure N3D1Click(Sender: TObject);
    procedure pm1TypeClick(Sender: TObject);
    procedure pm2OnClick(Sender: TObject);
    procedure Doughnut1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure N3D2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
var
  i, j: Integer;
begin
  Randomize;
  with SChart1 do
  begin
    BeginUpdate;
    DataValues[1, 1] := 2500;
    DataValues[1, 2] := 2000;
    DataValues[1, 3] := 500;
    DataValues[1, 4] := 1250;
    PointLabels[1] := 'US';
    PointLabels[2] := 'Japan';
    PointLabels[3] := 'Far East';
    PointLabels[4] := 'Europe';
    EndUpdate;
  end;
  with SChart2 do
  begin
    BeginUpdate;
    for i := 1 to NSeries do
      for j := 1 to NPoint do
        DataValues[i, j] := 10+Random( 90 );
    for i := 1 to NPoint do
      PointLabels[i] := ShortDayNames[i];    
    EndUpdate;
  end;
  with SChart3 do
  begin
    BeginUpdate;
    for i := 1 to NSeries do
      for j := 1 to NPoint do
        DataValues[i, j] := Random( 100 );
    SeriesLabels[1] := 'Series 1';
    SeriesLabels[2] := 'Series 2';
    SeriesLabels[3] := 'Series 3';
    SeriesLabels[4] := 'Series 4';
    for i := 1 to NPoint do
      PointLabels[i] := ShortDayNames[i];
    EndUpdate;
  end;
  with SChart4 do
  begin
    for i := 1 to NSeries do
      for j := 1 to NPoint do
        DataValues[i, j] := Random( 100 );
    for i := 1 to NPoint do
      PointLabels[i] := IntToStr( i );
  end;
end;

procedure TForm1.SChart1Click(Sender: TObject; ASeries, APoint,
  ALegend: Integer);
var
  s: string;
begin
  s := 'You clicked slice #'+IntToStr( APoint );
  Application.MessageBox( PChar( s ), 'SimChart', MB_OK or MB_ICONINFORMATION );
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  with SChart4 do
  begin
    BeginUpdate;
    SHLPoint( 1 );
    DataValues[1, 6] := Random( 100 );
    DataValues[2, 6] := Random( 100 );
    PointLabels[6] := IntToStr( StrToInt( PointLabels[5] )+1 );
    EndUpdate;
  end;
end;

procedure TForm1.SChart3Click(Sender: TObject; ASeries, APoint,
  ALegend: Integer);
begin
  if ASeries > 1 then
    SChart3.SwapSeries( ASeries, 1 );
  if ALegend > 1 then
    SChart3.SwapSeries( ALegend, 1 );
end;

procedure TForm1.N3D1Click(Sender: TObject);
begin
  SChart4.Chart3D := not SChart4.Chart3D;
  N3D1.Checked := SChart4.Chart3D;
end;

procedure TForm1.pm1TypeClick(Sender: TObject);
begin
  case TMenuItem( Sender ).Tag of
    0: SChart4.Kind := ckLine;
    1: SChart4.Kind := ckBar;
    2: SChart4.Kind := ckArea;
  end;
  TMenuItem( Sender ).Checked := True;
end;

procedure TForm1.pm2OnClick(Sender: TObject);
begin
  TMenuItem( Sender ).Checked := True;
  if Stacked1.Checked then
  begin
    if Area2.Checked then SChart2.Kind := ckSArea else
    if Bar2.Checked then SChart2.Kind := ckSBar else
    if HorizontalBar1.Checked then SChart2.Kind := ckSHBar;
  end else
  begin
    if Area2.Checked then SChart2.Kind := ckS100Area else
    if Bar2.Checked then SChart2.Kind := ckS100Bar else
    if HorizontalBar1.Checked then SChart2.Kind := ckS100HBar;
  end;
end;

procedure TForm1.Doughnut1Click(Sender: TObject);
begin
  Timer1.Enabled := False;
  Form2.ShowModal;
  Timer1.Enabled := True;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.N3D2Click(Sender: TObject);
begin
  SChart2.Chart3D := not SChart2.Chart3D;
  N3D2.Checked := SChart2.Chart3D;
end;

end.
